#include "convertIIC.h"






int ConvertBUS(LA_HWInfo HWInfo, int nChannel, BUSConfig BusCfg, unsigned char *cBuffer,
				LL_DataNode **dList)

{
	bool bExtendedDebug = false;

	char *msg;	
	msg = (char*)malloc(sizeof(char)*1000);

	if (BusCfg.nChannelStart > BusCfg.nChannelEnd)
	{
		int nTmp = BusCfg.nChannelStart;
		BusCfg.nChannelStart = BusCfg.nChannelEnd;
		BusCfg.nChannelEnd = nTmp;
	}

		#ifdef DebugMode
			sprintf(msg, "         ConvertBUS(); Begin (Start: %d; End: %d\n", BusCfg.nChannelStart, BusCfg.nChannelEnd);	
			PrintDebug(msg);
		#endif
	





	if (cBuffer == NULL)
	{
		#ifdef DebugMode
			sprintf(msg, "             - Error: la_buffer = NULL\n");

			PrintDebug(msg);
		#endif
		return 0;
	}


	ULONG nNumData = 0;
	int nNumMultiChan = (BusCfg.nChannelEnd - BusCfg.nChannelStart) + 1; //z.B. (4-2) + 1
	int k;	//Schleifenvariable

	unsigned long t1,t2;
	DWORD dStart = GetTickCount();

	unsigned char *cChanState, *cChanStateLast;
	cChanState = (unsigned char*)malloc(nNumMultiChan * sizeof(unsigned char));
	cChanStateLast = (unsigned char*)malloc(nNumMultiChan * sizeof(unsigned char));



	sData Data;
	bool bChanged = false;

	t1 = 0;
	t2 = HWInfo.samples_max;

	//durchlaufe alle Samples
	for (ULONG i=t1; i<=t2;i++)
	{
		//aktuellen Kanal-Werte speichern
		for (k=0;k<nNumMultiChan;k++)
			cChanState[k] = IsSet(HWInfo, cBuffer, BusCfg.nChannelStart+k, i);


		//nderungen feststellen
		for (k=0;k<nNumMultiChan;k++)
			if (cChanState[k] != cChanStateLast[k])
				bChanged = true;

		//Gab es eine nderung/erste Runde?
		if (i == t1 || bChanged == true)
		{
			//Gab es eine nderung (erste Runde ausschlieen)
			if (i != t1 && bChanged == true)
			{
				//Datenpaket abschlieen
				Data.nLength = i - Data.nStart;

				switch(BusCfg.cType)
				{
				case 1: //decimal
					itoa(Data.nValue,Data.cStr,10);
					break;
				case 2: //hex
					itoa(Data.nValue,Data.cStr,16);
					break;
				case 3: //bin
					itoa(Data.nValue,Data.cStr,2);

				}

				//Datenpaket hinzufgen
				(*dList) = LL_DataAdd((*dList), Data);
			/*
				#ifdef DebugMode
					sprintf(msg, "                Data End(%d): Length=%d\n", 
										nNumData, Data.nLength);

					PrintDebug(msg);
				#endif
			*/

				nNumData++;
			}

			//neues Paket vorbereiten
			Data.nStart = i;
			Data.cChannel = (char) nChannel;
			Data.cText = 0;
			Data.cColor = 0;
			Data.cType = 0;
			Data.nValue = 0;

			for (k=0;k<nNumMultiChan;k++)
			{
				if (cChanState[k] == 1)
				{
					Data.nValue += potentiate(2, k);
				}
			}

		/* Testausgaben: kosten viel Zeit!
			#ifdef DebugMode
				sprintf(msg, "             - Data Begin(%d): Start=%d; Channel=%d; Value=%d\n", 
									nNumData, Data.nStart, Data.cChannel, Data.nValue);

				PrintDebug(msg);
			#endif
			*/
		
			itoa(Data.nValue,Data.cStr,10);


			bChanged = false;

		}



		//aktuelle Kanal-Werte in den Last-Puffer schreiben
		for (int k=0;k<nNumMultiChan;k++)
			cChanStateLast[k] = cChanState[k];

	}



	free(cChanState);
	free(cChanStateLast);
	free(msg);


	return nNumData;










	free(msg);

	return 0;
}