#include "de_la_exp1.h"

//Konvertierungsfunktionen
#include "convertSPI.h"
#include "convertRS232.h"
#include "convertCAN2.h"
#include "convertIIC.h"
#include "convertBUS.h"




/////////////////////////////////////////
//TODO:
//	- Parameter Funktion bearbeiten!!!



	bool APIENTRY DllMain( HANDLE hModule, 
						   DWORD  ul_reason_for_call, 
						   LPVOID lpReserved)
	{
		return TRUE;
	}


	dllExp ULONG LA_EXP_GetDLLVersion()
	{
		return DLL_VERSION;
	}

	dllExp char *LA_EXP_GetDLLDate()
	{
		//Max. 32 Zeichen
		return "29.07.2010\0";
	}

/////////////////////////////////////////
// Get Interpreter Names
//
// Liefert die Anzahl der einzelnen Interpreter
// sowie deren Namen zurck
/////////////////////////////////////////

	exC dllExp ULONG LA_EXP_GetInterpreterNames(ULONG todo, char * text, ULONG text_length)
	{
		//Anzahl der Interpreter: 5
		//	1: SPI
		//	2: RS232
		//	3: CAN 2.0
		//  4: IC
		//	5: BUS

		int ret=0;


		switch(todo)
		{
		case 0:	//Anzahl der Interpreter
			{
				ret = 5;
				break;
			}
		// Namen der Interpreter angeben
		case 1:
			{
				strncpy(text, "BUS\0", text_length);
				break;
			}
		case 2:
			{
				strncpy(text,"SPI\0",text_length);
				break;
			}
		case 3:
			{
				strncpy(text,"RS232\0",text_length);
				break;
			}
		case 4:
			{
				strncpy(text,"CAN 2.0\0", text_length);
				break;
			}
		case 5:
			{
				strncpy(text, "IC\0", text_length);
				break;
			}

		}

		//Debug-Ausgaben
		#ifdef DebugMode
			char *msg;
			msg = (char*)malloc(sizeof(char)*(text_length+100));
			sprintf(msg, " [DLL] GetInterpreterNames(ToDo = %d, TextLength = %d): return %d\n", todo, text_length, ret);	
			PrintDebug(msg);
			if (text != NULL)
				if (strlen(text) <= text_length)
				{
					sprintf(msg, " [DLL]        - Text: %s\n",text);	
					PrintDebug(msg);
				}
			free(msg);
		#endif

		return ret;
	}


/////////////////////////////////////////
// SetInterpreter
/////////////////////////////////////////
	
	dllExp ULONG LA_EXP_setInterpreter(ULONG channelNo, ULONG nInterpreter, ULONG parCount)
	{

		char *msg;
		msg = (char*)malloc(sizeof(char)*(400));

		switch(nInterpreter)
		{
		case 1:	//BUS
			{
				if (LL_ChanInfoGet(ChanList, channelNo) == NULL)
				{
					ChannelInfo ChanInfo;

					ChanInfo.bUseInterpreter = false;
					ChanInfo.nNumParamsSet	 = 0;
					ChanInfo.nChannel		 = channelNo;
					ChanInfo.nInterpreterNr  = nInterpreter;

					ChanList = LL_ChanInfoAdd(ChanList, ChanInfo);					

					#ifdef DebugMode
						sprintf(msg, " [DLL] SetInterpreter(): Erkannter Interpreter: BUS (Kanal %d   Interpreter: %d  Anz.Param.: %d)\n",
												channelNo, nInterpreter, parCount);	
						PrintDebug(msg);
					#endif

				}
				else
				{
					#ifdef DebugMode
						sprintf(msg, " [DLL] SetInterpreter(): Fehler: Kanal %d bereits belegt!\n",
												channelNo);	
						PrintDebug(msg);
					#endif
				}

				break;
			}
		case 2://SPI
			{
				if (LL_ChanInfoGet(ChanList, channelNo) == NULL)
				{
					//Neuen Interpreter hinzufgen:
					ChannelInfo ChanInfo;
					
					ChanInfo.bUseInterpreter = false;
					ChanInfo.nNumParamsSet	 = 0;
					ChanInfo.nChannel		 = channelNo;
					ChanInfo.nInterpreterNr  = nInterpreter;

					ChanList = LL_ChanInfoAdd(ChanList, ChanInfo);

					#ifdef DebugMode
						sprintf(msg, " [DLL] SetInterpreter(): Erkannter Interpreter: SPI (Kanal %d   Interpreter: %d Anz.Param.: %d)\n", 
											channelNo, nInterpreter, parCount);	
						PrintDebug(msg);
					#endif

				}
				else
				{
					#ifdef DebugMode
						sprintf(msg, " [DLL] SetInterpreter(): Fehler: Kanal %d bereits belegt!\n",
												channelNo);	
						PrintDebug(msg);
					#endif
				}



				break;
			}
		case 3: //RS232
			{
				if (LL_ChanInfoGet(ChanList, channelNo) == NULL)
				{

					ChannelInfo ChanInfo;
					
					ChanInfo.bUseInterpreter = false;
					ChanInfo.nNumParamsSet	 = 0;
					ChanInfo.nChannel		 = channelNo;
					ChanInfo.nInterpreterNr  = nInterpreter;

					ChanList = LL_ChanInfoAdd(ChanList, ChanInfo);					

					#ifdef DebugMode
						sprintf(msg, " [DLL] SetInterpreter(): Erkannter Interpreter: CAN 2.0 (Kanal %d   Interpreter: %d  Anz.Param.: %d)\n",
												channelNo, nInterpreter, parCount);	
						PrintDebug(msg);
					#endif
				}
				else
				{
					#ifdef DebugMode
						sprintf(msg, " [DLL] SetInterpreter(): Fehler: Kanal %d bereits belegt!\n",
												channelNo);	
						PrintDebug(msg);
					#endif
				}


				break;
			}
		case 4:	//CAN 2.0
			{
				if (LL_ChanInfoGet(ChanList, channelNo) == NULL)
				{
		

					ChannelInfo ChanInfo;
					
					ChanInfo.bUseInterpreter = false;
					ChanInfo.nNumParamsSet	 = 0;
					ChanInfo.nChannel		 = channelNo;
					ChanInfo.nInterpreterNr  = nInterpreter;

					ChanList = LL_ChanInfoAdd(ChanList, ChanInfo);					

					#ifdef DebugMode
						sprintf(msg, " [DLL] SetInterpreter(): Erkannter Interpreter: CAN 2.0 (Kanal %d   Interpreter: %d  Anz.Param.: %d)\n",
												channelNo, nInterpreter, parCount);	
						PrintDebug(msg);
					#endif
				}
				else
				{
					#ifdef DebugMode
						sprintf(msg, " [DLL] SetInterpreter(): Fehler: Kanal %d bereits belegt!\n",
												channelNo);	
						PrintDebug(msg);
					#endif
				}
				break;
			}
		case 5:	// IIC
			{
				if (LL_ChanInfoGet(ChanList, channelNo) == NULL)
				{

					ChannelInfo ChanInfo;

					ChanInfo.bUseInterpreter = false;
					ChanInfo.nNumParamsSet	 = 0;
					ChanInfo.nChannel		 = channelNo;
					ChanInfo.nInterpreterNr  = nInterpreter;

					ChanList = LL_ChanInfoAdd(ChanList, ChanInfo);					

					#ifdef DebugMode
						sprintf(msg, " [DLL] SetInterpreter(): Erkannter Interpreter: IC (Kanal %d   Interpreter: %d  Anz.Param.: %d)\n",
												channelNo, nInterpreter, parCount);	
						PrintDebug(msg);
					#endif
				}
				else
				{
					#ifdef DebugMode
						sprintf(msg, " [DLL] SetInterpreter(): Fehler: Kanal %d bereits belegt!\n",
												channelNo);	
						PrintDebug(msg);
					#endif
				}
				break;
			}

		default:
			{
				#ifdef DebugMode
					sprintf(msg, " [DLL] SetInterpreter(): Unbekannter Interpreter (Kanal %d   Interpreter: %d  Anz.Param.: %d\n",
											channelNo, nInterpreter, parCount);	
					PrintDebug(msg);
				#endif
				break;
			}
		}
		return 0;
	}
	
		// Logi+ liefert den ausgewhlten Interpreter fr channelNo
		// *text = Namen des Interpreters 
		// *text_length = Lnge des Interpreternamen (maximal 100 Zeichen)
		//*parCount =  Anzahl der Parameter fr diesen Interpreter

//Neuen Messung!

	exC dllExp	void LA_EXP_startNew()
	{
		#ifdef DebugMode
			char *msg = (char*)malloc(sizeof(char)*50);
			sprintf(msg, " [DLL] startNew()\n");	
			PrintDebug(msg);
			free(msg);
		#endif
		ChanList = LL_ChanInfoClearList(ChanList);
	}



/////////////////////////////////////////
// Get Configuration Info
/////////////////////////////////////////

	exC dllExp ULONG LA_EXP_GetConfigurationInfo(ULONG InterpreterNr, ULONG todo, char * name, 
											 ULONG name_length, char * auswahl, ULONG auswahl_length)
	{

				#ifdef DebugMode
			char *msg;
			msg = (char*)malloc(sizeof(char)*(100));
			sprintf(msg, " [DLL] GetConfiguration (Interpreter-Nr: %d; todo: %d", InterpreterNr, todo);	
			PrintDebug(msg);
			free(msg);
		#endif

		int nRet;

		nRet = 0;

		switch(InterpreterNr)
		{
		case 1:	//BUS-Addition
			{
				switch(todo)
				{
				case 0:		//Anzahl der Parameter BUS
					return 3;
					break;

				case 1:
					{
							nRet = PARAM_SELECTION;
							strncpy(name, "Darstellung\0", name_length);
							strncpy(auswahl, "Dezimal;Hexadezimal;Binr\0", auswahl_length);
							break;					
					}

				case 2:		//Kanal [SCL]
					{
						nRet = PARAM_CHANNEL;
						strncpy(name, "Start\0", name_length);
						break;
					}
				case 3:		//Kanal [Data]
					{
						nRet = PARAM_CHANNEL;
						strncpy(name, "End\0", name_length);
						break;
					}
				}
				break;
			}
		// SPI
		case 2:
			{
				switch(todo)
				{	
					//Anz. d. Parameter
					case 0: 
						{
							return 7;
							break;
						}
					// Zahlensystem
					case 1:
						{
							nRet = PARAM_SELECTION;
							strncpy(name, "Darstellung\0", name_length);
							strncpy(auswahl, "Dezimal;Hexadezimal;Binr;ASCII\0", auswahl_length);

							break;
						}
					// Clock-Signal
					case 2: 
						{
							nRet = PARAM_CHANNEL; 
							strncpy(name, "Clock\0", name_length); 

							break;
						}

					//Datenleitung MISO/MOSI
					case 3: 
						{
							nRet = PARAM_CHANNEL; 
							strncpy(name, "MISO/MOSI\0", name_length);

							break;
						}
					//CS
					case 4:
						{
							nRet = PARAM_CHANNEL; 
							strncpy(name, "Chip Select\0", name_length);
							break;
						}
					//CS low-active?
					case 5:
						{
							nRet = PARAM_SELECTION; 
							strncpy(name, "Chip-Select\0", name_length);


							strncpy(auswahl, "low-active;high-active\0",auswahl_length);
							break;
						}
					//Datenbernahme
					case 6: 
						{
							nRet = PARAM_SELECTION; 
							strncpy(name, "Datenbernahme\0", name_length);


							strncpy(auswahl, 
								 "bei steigender Flanke;bei fallender Flanke",auswahl_length);
							break;
						}
					//Bit Anzahl
					case 7: 
						{
							nRet = PARAM_SELECTION; 
							strncpy(name, "Daten-Bits\0", name_length);


							strncpy(auswahl, "8;16;24;32\0",auswahl_length);
							break;
						}


				}		
				break;
			}

		//RS232
		case 3:
			{
				switch(todo)
				{
				//Anzahl der Parameter
				case 0:
					{
						return 6;
						break;
					}
				// Zahlensystem
				case 1:
					{
						nRet = PARAM_SELECTION;
						strncpy(name, "Darstellung\0", name_length);
						strncpy(auswahl, "Dezimal;Hexadezimal;Binr;ASCII\0", auswahl_length);

						break;
					}
				//Datenleitung RxD/TxD
				case 2:
					{
							nRet = PARAM_CHANNEL; 
							strncpy(name, "RxD/TxD\0", name_length);
							
							break;
					}
				//Baudrate
				case 3:
					{
							nRet = PARAM_TEXT; 
//							nRet = PARAM_SELECTION;

							strncpy(name, "Baudrate\0", name_length); 
							strncpy(auswahl, "9600",auswahl_length);
							strncpy(auswahl, "50;300;600;1200;2400;4800;9600;14400;19200;28800;38400;56k;57600;115200;128k;230k4;256k;460k8;500k",auswahl_length);
							break;						
					}

				//Bit Anzahl
				case 4:
					{
							nRet = PARAM_SELECTION; 

							strncpy(name, "Bit-Anzahl\0", name_length); 
							strncpy(auswahl, "2;3;4;5;6;7;8;9;10;11;12;13;14;15;16;17;18;19;20;21;22;23;24\0",auswahl_length);

							break;	
					}

				//Paritts-Bit
				case 5:
					{
							nRet = PARAM_SELECTION; 

							strncpy(name, "Paritts-Bit\0", name_length); 
							strncpy(auswahl, "None;Odd;Even;Mark;Space\0",auswahl_length);

							break;					
					}

				//Anz der Stop-Bits
				case 6:
					{
							nRet = PARAM_SELECTION; 

							strncpy(name, "Stop-Bits\0", name_length); 
							strncpy(auswahl, "1 ;1,5 ;2\0",auswahl_length);

							break;
					}

				}

				break;

			}
		//CAN 2.0
		case 4:
			{
				switch(todo)
				{
				//Anzahl der Parameter
				case 0:
					return 4;
					break;

				case 1:
					{
						nRet = PARAM_SELECTION;
						strncpy(name, "Darstellung\0", name_length);
						strncpy(auswahl, "Dezimal;Hexadezimal;Binr;ASCII\0", auswahl_length);
						break;
					}
				//Datenleitung
				case 2:
					{
						nRet = PARAM_CHANNEL;
						strncpy(name, "Data\0", name_length);
						break;
					}
				//Baudrate
				case 3:
					{
							nRet = PARAM_TEXT;

							strncpy(name, "Baudrate\0", name_length); 
							strncpy(auswahl, "1000000", auswahl_length);
							//strncpy(auswahl, "125kBit;250kBit;500kBit;750kBit;1MBit;1,5MBit;2MBit",auswahl_length);
							break;						
					}
				//Detailgrad
				case 4:
					{
						nRet = PARAM_SELECTION;

						strncpy(name, "Detailgrad\0", name_length);
						strncpy(auswahl, "Identifer+Daten; Identifer+Daten+Checksum", auswahl_length);
						break;
					}
	
				}
				break;
			}
			//IC
		case 5:
			{


				switch(todo)
				{
				case 0:		//Anz. der Parameter IIC
					return 3;
					break;
				case 1:		//Darstellung
					{
						nRet = PARAM_SELECTION;
						strncpy(name, "Darstellung\0", name_length);
						strncpy(auswahl, "Dezimal;Hexadezimal;Binr\0", auswahl_length);
						break;
					}
				case 2:		//Kanal [SCL]
					{
						nRet = PARAM_CHANNEL;
						strncpy(name, "Clock\0", name_length);
						break;
					}
				case 3:		//Kanal [Data]
					{
						nRet = PARAM_CHANNEL;
						strncpy(name, "Data\0", name_length);
						break;
					}
				case 4:
					{
						nRet = PARAM_SELECTION;
						strncpy(name, "Adresse\0", name_length);
						strncpy(auswahl, "Dezimal;Hexadezimal;Binr\0", auswahl_length);
						break;
					}
				}
			}
			

		}


		return nRet;
	}




/////////////////////////////////////////
// SetConfiguration
/////////////////////////////////////////

	dllExp ULONG LA_EXP_setConfiguration(ULONG channelNo, ULONG parNo, ULONG nChannel, ULONG nSelection)
	{
		char *msg;
		msg = (char*)malloc(sizeof(char)*(400));


		if (LL_ChanInfoGet(ChanList, channelNo) == NULL)
		{
			#ifdef DebugMode
				sprintf(msg, " [DLL] SetConfig(): ChanNr: %d nicht gefunden!\n", channelNo);	
				PrintDebug(msg);
			#endif
			free(msg);
			return 1;
		}
		ChanList = LL_ChanInfoGet(ChanList, channelNo);

		//Was ist der Parameter-Typ?

		switch(ChanList->ChanInfo.nInterpreterNr)
		{

		case 1:		//BUS-Addierer
			{
				//alle Parameter mssen nach der Reihe durchgereicht werden!
				if (parNo != (ULONG)(ChanList->ChanInfo.nNumParamsSet+1))
				{
					#ifdef DebugMode
						sprintf(msg, " [DLL] SetConfig(): ChanNr: %d, parNr: %d, [BUS] VORSICHT: Parameter bitte nacheinander angeben,.\n", 
														channelNo, parNo);	
						PrintDebug(msg);
					#endif
				}

				switch(parNo)	// 4 Parameter (Type, Clk, Data, Adresse)
				{
				case 1:	//Type			- Auswahl
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [BUS] Type: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nSelection);	
							PrintDebug(msg);
						#endif

						ChanList->ChanInfo.BusCfg.cType = (unsigned char)nSelection;
						ChanList->ChanInfo.nNumParamsSet++;

						break;
					}

				case 2: //Start
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [BUS] Start-Kanal: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nChannel-1);	
							PrintDebug(msg);
						#endif

						ChanList->ChanInfo.BusCfg.nChannelStart = (unsigned char)nChannel-1;
						ChanList->ChanInfo.nNumParamsSet++;

						break;
					}

				case 3: //End
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [BUS] End-Kanal: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nChannel-1);	
							PrintDebug(msg);
						#endif

						ChanList->ChanInfo.BusCfg.nChannelEnd = (unsigned char)nChannel-1;
						ChanList->ChanInfo.nNumParamsSet++;
						ChanList->ChanInfo.bUseInterpreter = true;
					

						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig() : [BUS] Kanal(%d) : Konfiguration abgeschlossen\n", 
															channelNo);		
							PrintDebug(msg);
						#endif

						break;
					}

				}
				break;
			}


		case 2:			// SPI
			{

				//alle Parameter mssen nach der Reihe durchgereicht werden!
				if (parNo != (ULONG)(ChanList->ChanInfo.nNumParamsSet+1))
				{
					#ifdef DebugMode
						sprintf(msg, " [DLL] SetConfig(): ChanNr: %d, parNr: %d, [SPI] VORSICHT: Parameter bitte nacheinander angeben,.\n", 
														channelNo, parNo);	
						PrintDebug(msg);
					#endif
				}

				switch(parNo)		// 7 Parameter (Type, Clk, Data, CS, CS-Active high/low, Mode, Bit-Anz)
				{
				case 1:	//Type			- Auswahl
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [SPI] Type: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nSelection);	
							PrintDebug(msg);
						#endif

						ChanList->ChanInfo.SpiCfg.cType = (unsigned char)nSelection;
						ChanList->ChanInfo.nNumParamsSet++;

						break;
					}
				case 2:	//Clk			- Kanalauswahl
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [SPI] Clock-Kanal: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nChannel-1);	
							PrintDebug(msg);
						#endif

						ChanList->ChanInfo.SpiCfg.nChannelClk = nChannel-1;
						ChanList->ChanInfo.nNumParamsSet++;

						break;
					}
				case 3:	//Datenleitung	- Kanalauswahl
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [SPI] DATA-Kanal: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nChannel-1);	
							PrintDebug(msg);
						#endif

						ChanList->ChanInfo.SpiCfg.nChannelData = nChannel-1;
						ChanList->ChanInfo.nNumParamsSet++;

						break;
					}
				case 4:	//CS			- Kanalauswahl
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [SPI] CS-Kanal: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nChannel-1);	
							PrintDebug(msg);
						#endif

						ChanList->ChanInfo.SpiCfg.nChannelCS = nChannel-1;
						ChanList->ChanInfo.nNumParamsSet++;

						break;
					}
				case 5:	//CS Active low/high- Kanalauswahl
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [SPI] CS-Active-Indx: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nSelection);	
							PrintDebug(msg);
						#endif

						ChanList->ChanInfo.SpiCfg.nCSActive = nSelection-1;
						ChanList->ChanInfo.nNumParamsSet++;

						break;
					}
				case 6:	//Datenbernahme			- Auswahl (steigende Flanke/fallende Flanke)
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [SPI] Datenbernahme-Index: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nSelection);	
							PrintDebug(msg);
						#endif

						if (nSelection > 2 || nSelection < 1)
						{
							#ifdef DebugMode
								sprintf(msg, "          Fehler: Datenbername ist nicht zulssig!\n");	
								PrintDebug(msg);
							#endif
						}

						if (nSelection == 1)
							ChanList->ChanInfo.SpiCfg.nRisingEdge = 1;
						else
							ChanList->ChanInfo.SpiCfg.nRisingEdge = 0;

						ChanList->ChanInfo.nNumParamsSet++;

						break;
					}
				case 7:	//Bit-Anzahl	- Auswahl (8,16,24,32)
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [SPI] Bit-Index: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nSelection);	
							PrintDebug(msg);
						#endif

						ChanList->ChanInfo.SpiCfg.nNumBits = nSelection *8;
						ChanList->ChanInfo.nNumParamsSet++;
						ChanList->ChanInfo.bUseInterpreter = true;

						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig() : [SPI] Kanal(%d) : Konfiguration abgeschlossen\n", 
															channelNo);	
							PrintDebug(msg);
						#endif
						break;
					}

				}
				break;
			}

		case 3:	//RS232
			{

				//alle Parameter mssen nach der Reihe durchgereicht werden!
				if (parNo != (ULONG)(ChanList->ChanInfo.nNumParamsSet+1))
				{
					#ifdef DebugMode
						sprintf(msg, " [DLL] SetConfig(): ChanNr: %d, parNr: %d, [RS232] VORSICHT: Parameter bitte nacheinander angeben,.\n", 
														channelNo, parNo);	
						PrintDebug(msg);
					#endif
				}


				switch(parNo)	// 6 Parameter (Type, Data, Baud, Bit-Anzahl, Paritts-bits, Stop-Bits)
				{
				case 1:	//Type			- Auswahl
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [RS232] Type: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nSelection);	
							PrintDebug(msg);
						#endif

						ChanList->ChanInfo.RsCfg.cType = (unsigned char)nSelection;
						ChanList->ChanInfo.nNumParamsSet++;

						break;
					}
				case 2:	//Datenleitung			- Kanalauswahl
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [RS232] Daten-Kanal: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nChannel);	
							PrintDebug(msg);
						#endif

						ChanList->ChanInfo.RsCfg.nChannelData = nChannel-1;
						ChanList->ChanInfo.nNumParamsSet++;

						break;
					}

				case 3:	//Baud			- Auswahl 
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [RS232] Baud-Index: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nSelection);	
							PrintDebug(msg);
						#endif

						int nBaud = 0;

						switch(nSelection)
						{
						case 1: nBaud = 50;			break;
						case 2: nBaud = 300;		break;
						case 3: nBaud = 600;		break;
						case 4: nBaud = 1200;		break;
						case 5: nBaud = 2400;		break;
						case 6: nBaud = 4800;		break;
						case 7: nBaud = 9600;		break;
						case 8: nBaud = 14400;		break;
						case 9: nBaud = 19200;		break;
						case 10: nBaud = 28800;		break;
						case 11: nBaud = 38400;		break;
						case 12: nBaud = 56000;		break;
						case 13: nBaud = 57600;		break;
						case 14: nBaud = 115200;	break;
						case 15: nBaud = 128000;	break;
						case 16: nBaud = 230400;	break;
						case 17: nBaud = 256000;	break;
						case 18: nBaud = 460800;	break;
						case 19: nBaud = 500000;	break;
						default: nBaud = 0;			break;
						}

						
//NDERUNG: freier Text


						ChanList->ChanInfo.RsCfg.nBaud = nBaud;
						ChanList->ChanInfo.nNumParamsSet++;

						break;
					}

				case 4: //Bits			- Auswahl (2;3;4;5;6;7;8;9;10;11;12;13;14;15;16;17;18;19;20;21;22;23;24)
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [RS232] Bit-Index: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nSelection);	
							PrintDebug(msg);
						#endif

						if (nSelection > 23)
							ChanList->ChanInfo.RsCfg.nNumBits = 0;
						else
							ChanList->ChanInfo.RsCfg.nNumBits = nSelection + 1;

						ChanList->ChanInfo.nNumParamsSet++;

						break;
					}

				case 5: //Paritts-Bit	- Auswahl (None;Odd;Even;Mark;Space)
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [RS232] P.Bit-Index: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nSelection);	
							PrintDebug(msg);
						#endif

						if (nSelection > 5)
							ChanList->ChanInfo.RsCfg.nParityBit = PAR_NONE;
						else
							ChanList->ChanInfo.RsCfg.nParityBit = nSelection;

						ChanList->ChanInfo.nNumParamsSet++;

						break;
					}

				case 6: //Stop-Bits		- Auswahl (1;1.5;2)
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [RS232] S.Bit-Index: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nSelection);	
							PrintDebug(msg);
						#endif

						switch(nSelection)
						{
							case 1:	ChanList->ChanInfo.RsCfg.fNumStopBits = 1.0f; break;
							case 2:	ChanList->ChanInfo.RsCfg.fNumStopBits = 1.5f; break;
							case 3:	ChanList->ChanInfo.RsCfg.fNumStopBits = 2.0f; break;

							default:	ChanList->ChanInfo.RsCfg.fNumStopBits = 1.0f; break;
						}

						ChanList->ChanInfo.nNumParamsSet++;
						ChanList->ChanInfo.bUseInterpreter = true;

						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig() : [RS232] Kanal(%d) : Konfiguration abgeschlossen\n", 
															channelNo);		
							PrintDebug(msg);
						#endif

						break;
					}

				}

				break;
			}
		//CAN 2.0
		case 4:
			{

				//alle Parameter mssen nach der Reihe durchgereicht werden!
				if (parNo != (ULONG)(ChanList->ChanInfo.nNumParamsSet+1))
				{
					#ifdef DebugMode
						sprintf(msg, " [DLL] SetConfig(): ChanNr: %d, parNr: %d, [CAN 2.0] VORSICHT: Parameter bitte nacheinander angeben,.\n", 
														channelNo, parNo);	
						PrintDebug(msg);
					#endif
				}


				switch(parNo)	// 4 Parameter (Type, Channel, Baud, Detail)
				{
				case 1:	//Type			- Auswahl
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [CAN 2.0] Type: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nSelection);	
							PrintDebug(msg);
						#endif

						ChanList->ChanInfo.CanCfg.cType = (unsigned char)nSelection;
						ChanList->ChanInfo.nNumParamsSet++;

						break;
					}

				case 2: //Data
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [CAN 2.0] Datenkanal: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nChannel-1);	
							PrintDebug(msg);
						#endif

						ChanList->ChanInfo.CanCfg.nChannelData = (unsigned char)nChannel-1;
						ChanList->ChanInfo.nNumParamsSet++;

						break;
					}

				case 3:	//Baud			- Auswahl
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [CAN 2.0] Baud-Index: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nSelection);	
							PrintDebug(msg);
						#endif

						int nBaud = 0;

						switch(nSelection)
						{
						case 1: nBaud = 125000;		break;
						case 2: nBaud = 250000;		break;
						case 3: nBaud = 500000;		break;
						case 4: nBaud = 750000;		break;
						case 5: nBaud = 1000000;	break;
						case 6: nBaud = 1500000;	break;
						case 7: nBaud = 2000000;	break;
						default: nBaud = 0;			break;
						}

						
//NDERUNG: freier Text


						ChanList->ChanInfo.CanCfg.nBaud = nBaud;
						ChanList->ChanInfo.nNumParamsSet++;

						break;
					}
				case 4:
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [CAN 2.0] Detail: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nSelection);	
							PrintDebug(msg);
						#endif

						ChanList->ChanInfo.CanCfg.cDetail = (unsigned char)nSelection;
						ChanList->ChanInfo.nNumParamsSet++;
						ChanList->ChanInfo.bUseInterpreter = true;

						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig() : [CAN] Kanal(%d) : Konfiguration abgeschlossen\n", 
															channelNo);		
							PrintDebug(msg);
						#endif

						break;
					}
				}
				break;
			}

		case 5:	//IC
			{

				//alle Parameter mssen nach der Reihe durchgereicht werden!
				if (parNo != (ULONG)(ChanList->ChanInfo.nNumParamsSet+1))
				{
					#ifdef DebugMode
						sprintf(msg, " [DLL] SetConfig(): ChanNr: %d, parNr: %d, [IC] VORSICHT: Parameter bitte nacheinander angeben,.\n", 
														channelNo, parNo);	
						PrintDebug(msg);
					#endif
				}

				switch(parNo)	// 4 Parameter (Type, Clk, Data, Adresse)
				{
				case 1:	//Type			- Auswahl
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [IC] Type: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nSelection);	
							PrintDebug(msg);
						#endif

						ChanList->ChanInfo.IicCfg.cType = (unsigned char)nSelection;
						ChanList->ChanInfo.nNumParamsSet++;

						break;
					}

				case 2: //Clock
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [IC] Clock-Kanal: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nChannel-1);	
							PrintDebug(msg);
						#endif

						ChanList->ChanInfo.IicCfg.nChannelClk = (unsigned char)nChannel-1;
						ChanList->ChanInfo.nNumParamsSet++;

						break;
					}

				case 3: //Data
					{
						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig(ChanNr: %d, parNr: %d, Kanal: %d, Auswahl: %d) : [IC] Datenkanal: %d.\n", 
															channelNo, parNo, nChannel, nSelection, nChannel-1);	
							PrintDebug(msg);
						#endif

						ChanList->ChanInfo.IicCfg.nChannelData = (unsigned char)nChannel-1;
						ChanList->ChanInfo.nNumParamsSet++;
						ChanList->ChanInfo.bUseInterpreter = true;

						#ifdef DebugMode
							sprintf(msg, " [DLL] SetConfig() : [IIC] Kanal(%d) : Konfiguration abgeschlossen\n", 
															channelNo);		
							PrintDebug(msg);
						#endif

						break;
					}


				}

				break;
			}



		}

		free(msg);
		return 0;
	}


//////////////////
// Interpretieren
//////////////////

/*

	Diese Funktion muss beim starten der Messung, nachdem die 
	Spezialkanle mit Ihrem einstellungen bergeben werden, 
	aufgerufen werden.
 */

dllExp ULONG la_exp_interprete_data(LA_HWInfo HWInfo, LA_Configuration LAConf, 
									unsigned char *la_buffer, unsigned int todo)
{

	char *msg;
	int i;

	msg = (char*)malloc(sizeof(char)*1000);


	#ifdef DebugMode
		sprintf(msg, " [DLL] interprete_data(); todo = %d\n", todo);	
		PrintDebug(msg);
	#endif


	DWORD dStart = GetTickCount();

	if (todo == 0)
	{

		if (la_buffer == NULL)
		{
			#ifdef DebugMode
				sprintf(msg, " [DLL] interprete_data(); Fehler: la_buffer = NULL\n");	
				PrintDebug(msg);
			#endif
			free(msg);
			return 1;
		}


		//LA Buffer in den gl_buffer kopieren (spter wichtig fr die Berechnung 
		// der Multi-Channel
/*
		if (gl_buffer != NULL)
			free(gl_buffer);

		#ifdef DebugMode
			sprintf(msg, " [DLL] interprete_data(); kopiere la_buffer\n");	
			PrintDebug(msg);
		#endif

		nBufferSize = HWInfo.bytes_per_sample * HWInfo.samples_max;
		gl_buffer = (unsigned char*)malloc(nBufferSize);
		memcpy(gl_buffer, la_buffer, nBufferSize);

*/

		if (DataList != NULL)
		{
			DataList = LL_DataClearList(DataList);
		}


		DataList = NULL;

		//interpretieren
		//alle Spezial-Kanle Durchlaufen
		
		int nNumChan =0;

		//Keine Daten zu interpretieren!
		if (ChanList == NULL)
		{
			#ifdef DebugMode
				sprintf(msg, " [DLL] interprete_data(); Keine Spezialkanle gewhlt.\n");	
				PrintDebug(msg);
			#endif
			free(msg);
			return 1;
		}


		nNumChan = LL_ChanInfoGetNumElements(ChanList);


			#ifdef DebugMode
				sprintf(msg, " [DLL] interprete_data(); Anzahl d. Spezialkanle: %d\n", nNumChan);	
				PrintDebug(msg);
			#endif

		ChanList = LL_ChanInfoGetFirst(ChanList);



		for (i=0;i<nNumChan;i++)
		{

			if (ChanList != NULL)
			{
				
				if (ChanList->ChanInfo.bUseInterpreter == 1)
				{

					//welcher Interpreter?
					switch(ChanList->ChanInfo.nInterpreterNr)
					{
					case 1:		//BUS
						{
							int res;
							res = ConvertBUS(HWInfo, ChanList->ChanInfo.nChannel, 
											ChanList->ChanInfo.BusCfg, la_buffer, &DataList);

								#ifdef DebugMode
									sprintf(msg, "                            %d.Spezialkanal(Kanal: %d): BUS\n", 
																				i+1,ChanList->ChanInfo.nChannel);	
									PrintDebug(msg);
								#endif
							break;
						}
					case 2:		//SPI
						{
							int res;
							res = ConvertSpi(HWInfo, ChanList->ChanInfo.nChannel, ChanList->ChanInfo.SpiCfg, la_buffer, &DataList);
								#ifdef DebugMode
									sprintf(msg, "                            %d.Spezialkanal(%d): SPI\n", 
																				i+1,ChanList->ChanInfo.nChannel);
									PrintDebug(msg);
									sprintf(msg, "                               Ret.: %d\n", res);
									PrintDebug(msg);
								#endif

							break;
						}

					case 3:		//RS232
						{
							int res;
							res = ConvertRS232(HWInfo, LAConf, ChanList->ChanInfo.nChannel, 
											ChanList->ChanInfo.RsCfg, la_buffer, &DataList);
								#ifdef DebugMode
									sprintf(msg, "                            %d.Spezialkanal(Kanal: %d): RS232\n", 
																				i+1,ChanList->ChanInfo.nChannel);	
									PrintDebug(msg);
								#endif
							break;
						}
					case 4:
						{
							int res;
							res = ConvertCAN2(HWInfo, LAConf, ChanList->ChanInfo.nChannel, 
											ChanList->ChanInfo.CanCfg, la_buffer, &DataList);
								#ifdef DebugMode
									sprintf(msg, "                            %d.Spezialkanal(Kanal: %d): CAN 2.0\n", 
																				i+1,ChanList->ChanInfo.nChannel);	
									PrintDebug(msg);
								#endif
							break;
						}

					case 5:		//IC
						{
							int res;
							res = ConvertIIC(HWInfo, ChanList->ChanInfo.nChannel, 
											ChanList->ChanInfo.IicCfg, la_buffer, &DataList);
								#ifdef DebugMode
									sprintf(msg, "                            %d.Spezialkanal(Kanal: %d): IIC\n", 
																				i+1,ChanList->ChanInfo.nChannel);	
									PrintDebug(msg);
								#endif
							break;
						}

					}
				}

			//nchsten Spezialkanal abarbeiten
				if (i <nNumChan-1)
					ChanList = LL_ChanInfoGetNext(ChanList);
			}


			if (ChanList == NULL)
			{
				#ifdef DebugMode
					sprintf(msg, " [DLL] interprete_Data() ChanList == NULL; Abbruch!\n");	
					PrintDebug(msg);
				#endif
				break;
			}
		}

	}


	#ifdef DebugMode
		sprintf(msg, " [DLL] interprete_Data(); Interpretations-Dauer: %dms; Gefundene Pakete: %d\n",
			GetTickCount()-dStart,LL_DataGetNumElements(DataList));	
		PrintDebug(msg);
		
	#endif

	free(msg);

	return 1;
}

	char CalcByte(unsigned long nVal, unsigned int nNum)
	{
		char c;
		c = (char)(nVal >> (nNum*8) & 0xFF); 
		return c;
	}



	//Zum addieren mehrere Channel
	//soll durch einen Interpreter "BUS" ersetzt werden!
	dllExp ULONG la_exp_get_multi_data(LA_HWInfo HWInfo, unsigned char *la_buffer, 
		int nTodo, int nChannel, ULONG t1, ULONG t2, int nChanBegin, int nChanEnd, unsigned char* cData)
	{

		char *msg = (char*)malloc(sizeof(unsigned char)*500);


		#ifdef DebugMode
			sprintf(msg, " [DLL] get__multi_data(); todo = %d; nChannel = %d; t1 = %d, t2 = %d, nMultlBeg = %d, nMultiEnd = %d\n",
				nTodo, nChannel,t1,t2, nChanBegin, nChanEnd);

			PrintDebug(msg);
		#endif

		DWORD dStart = GetTickCount();

		//Daten auslesen und die Anzahl zurck geben
		if (nTodo == 0)
		{
			


			if (la_buffer == NULL)
			{
				#ifdef DebugMode
					sprintf(msg, "             - Error: la_buffer = NULL\n");

					PrintDebug(msg);
				#endif
				return 0;
			}

			if (t1 == t2 || t1 > t2)
			{
				#ifdef DebugMode
					sprintf(msg, "             - Error: check t1 <=> t2\n");

					PrintDebug(msg);
				#endif
				return 0;
			}

			if (HWInfo.samples_max < t1 ||
				HWInfo.samples_max < t2)
			{
				#ifdef DebugMode
					sprintf(msg, "             - Error: t1/t2\n");

					PrintDebug(msg);
				#endif
				return 0;
			}

			ULONG nNumData = 0;
			int nNumMultiChan = (nChanEnd - nChanBegin) + 1; //z.B. (4-2) + 1
			int k;	//Schleifenvariable

			unsigned char *cChanState, *cChanStateLast;
			cChanState = (unsigned char*)malloc(nNumMultiChan * sizeof(unsigned char));
			cChanStateLast = (unsigned char*)malloc(nNumMultiChan * sizeof(unsigned char));



			sData Data;
			bool bChanged = false;

			//durchlaufe alle Samples
			for (ULONG i=t1; i<=t2;i++)
			{
				//aktuellen Kanal-Werte speichern
				for (k=0;k<nNumMultiChan;k++)
					cChanState[k] = IsSet(HWInfo, la_buffer, nChanBegin+k, i);


				//nderungen feststellen
				for (k=0;k<nNumMultiChan;k++)
					if (cChanState[k] != cChanStateLast[k])
						bChanged = true;

				//Gab es eine nderung/erste Runde?
				if (i == t1 || bChanged == true)
				{
					//Gab es eine nderung (erste Runde ausschlieen)
					if (i != t1 && bChanged == true)
					{
						//Datenpaket abschlieen
						Data.nLength = i - Data.nStart;

						//Datenpaket hinzufgen
						DataMultiList = LL_DataAdd(DataMultiList, Data);
					/*
						#ifdef DebugMode
							sprintf(msg, "                Data End(%d): Length=%d\n", 
												nNumData, Data.nLength);

							PrintDebug(msg);
						#endif
					*/

						nNumData++;
					}

					//neues Paket vorbereiten
					Data.nStart = i;
					Data.cChannel = (char) nChannel;
					Data.cText = 0;
					Data.cColor = 0;
					Data.cType = 0;
					Data.nValue = 0;

					for (k=0;k<nNumMultiChan;k++)
					{
						if (cChanState[k] == 1)
						{
							Data.nValue += potentiate(2, k);
						}
					}

				/* Testausgaben: kosten viel Zeit!
					#ifdef DebugMode
						sprintf(msg, "             - Data Begin(%d): Start=%d; Channel=%d; Value=%d\n", 
											nNumData, Data.nStart, Data.cChannel, Data.nValue);

						PrintDebug(msg);
					#endif
					*/
				
					itoa(Data.nValue,Data.cStr,10);


					bChanged = false;

				}



				//aktuelle Kanal-Werte in den Last-Puffer schreiben
				for (int k=0;k<nNumMultiChan;k++)
					cChanStateLast[k] = cChanState[k];

			}




			#ifdef DebugMode
				sprintf(msg, "                get_multi_data Beendet (%dms)\n", 
								(GetTickCount() - dStart));

				PrintDebug(msg);
			#endif

			free(cChanState);
			free(cChanStateLast);
			free(msg);


			return nNumData;
		}

		//Daten zurck geben!
		if (nTodo == 1)
		{

/*
			if (nNumData < nNumElements)
			{
				#ifdef DebugMode
					sprintf(msg, "                   - Nicht ausreichend Platz ([nNumData] ist: %d; soll: %d).\n",
										nNumData, nNumElements);
					PrintDebug(msg);
				#endif
				free(msg);
				return 0;
			}
*/
			if (DataMultiList == NULL)
			{
				#ifdef DebugMode
					sprintf(msg, "                   - DataMultiList == NULL\n");
					PrintDebug(msg);
				#endif
				free(msg);
				return 0;
			}
	
			ULONG nNumElements;
			nNumElements = LL_DataGetNumElements(DataMultiList);

			DataMultiList = LL_DataGetFirst(DataMultiList);
			
			int nBitPos = 0;
			int nPaketSize = 45;

			//Daten zurckgeben
			for (ULONG i=0;i<nNumElements;i++)
			{
				if (DataMultiList == NULL)
				{
					free(msg);
					return -1;
				}

				nBitPos = 0;

				//Paket:
				//	0:		char cText
				//	1:		char cType
				//	2:		char cColor
				//	3:		char cChannel
				//	4-36:	char nValue
				//	37-40:	ULONG nStart
				//	41-44:	ULONG nLength

				cData[(i*nPaketSize)+nBitPos++] = DataMultiList->Data.cText;
				cData[(i*nPaketSize)+nBitPos++] = DataMultiList->Data.cType;
				cData[(i*nPaketSize)+nBitPos++] = DataMultiList->Data.cColor;
				cData[(i*nPaketSize)+nBitPos++] = DataMultiList->Data.cChannel;



				//nValue
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
/*
				cData[(i*16)+4] = CalcByte(DataTempList->Data.nValue,0);
				cData[(i*16)+5] = CalcByte(DataTempList->Data.nValue,1);
				cData[(i*16)+6] = CalcByte(DataTempList->Data.nValue,2);
				cData[(i*16)+7] = CalcByte(DataTempList->Data.nValue,3);
*/

				for (int j=0;j<33;j++)
					cData[(i*nPaketSize) + nBitPos++] = DataMultiList->Data.cStr[j];

				//nStart
				cData[(i*nPaketSize)+nBitPos++] = CalcByte(DataMultiList->Data.nStart,0);
				cData[(i*nPaketSize)+nBitPos++] = CalcByte(DataMultiList->Data.nStart,1);
				cData[(i*nPaketSize)+nBitPos++] = CalcByte(DataMultiList->Data.nStart,2);
				cData[(i*nPaketSize)+nBitPos++] = CalcByte(DataMultiList->Data.nStart,3);


				//nLength
				cData[(i*nPaketSize)+nBitPos++] = CalcByte(DataMultiList->Data.nLength,0);
				cData[(i*nPaketSize)+nBitPos++] = CalcByte(DataMultiList->Data.nLength,1);
				cData[(i*nPaketSize)+nBitPos++] = CalcByte(DataMultiList->Data.nLength,2);
				cData[(i*nPaketSize)+nBitPos++] = CalcByte(DataMultiList->Data.nLength,3);

				/* Testausgaben: kosten viel Zeit!
				#ifdef DebugMode
					sprintf(msg, "                   -  Paket %d; Start: %d; Length: %d\n",i,DataMultiList->Data.nStart,
											DataMultiList->Data.nLength);
					PrintDebug(msg);
				#endif
				*/



				//Nchstes Datenpaket (wenn dies nicht das letzte ist
				if (i != (nNumElements-1))
					DataMultiList = LL_DataGetNext(DataMultiList);

			}

				#ifdef DebugMode
					sprintf(msg, "                   -  %d Packete zurck gegeben; Dauer: %dms\n",
									LL_DataGetNumElements(DataMultiList), (GetTickCount()-dStart));
					PrintDebug(msg);
				#endif

			//Datenliste lschen

			if (DataMultiList != NULL)
				DataMultiList = LL_DataClearList(DataMultiList);

			DataMultiList = NULL;


		}

		free(msg);
		return 0;
	}



/////////////////////////////////////////
// Convert Data
/////////////////////////////////////////


	dllExp ULONG la_exp_get_data(ULONG todo, ULONG nNumData, unsigned char *cData,
									unsigned long t1, unsigned long t2)
	{
		
		char *msg;
		msg = (char*)malloc(sizeof(char)*400);

		#ifdef DebugMode
			sprintf(msg, " [DLL] get_data(); todo = %d; nNumData = %d, t1 = %d, t2 = %d\n", todo, nNumData,t1,t2);
			PrintDebug(msg);
		#endif

		DWORD dStart = GetTickCount();



		//todo == 0
		//Daten im Datenberecih zhlen und in 
		//die temprre Datenliste (DataTempList) einfgen

		if (todo == 0)
		{

			unsigned int nNumElements=0;

			if (DataTempList != NULL)
			{
				DataTempList = LL_DataClearList(DataTempList);
			}

			if (DataList == NULL)
			{
				#ifdef DebugMode
					sprintf(msg, "                   - DatenListe leer.\n");
					PrintDebug(msg);
				#endif
			}
			else
			{

				nNumElements = LL_DataGetNumElements(DataList);

				if (nNumElements == 0)
				{
					#ifdef DebugMode
						sprintf(msg, "                   - Keine Daten vorhanden.\n");
						PrintDebug(msg);
					#endif
				}
				else
				{

					DataList = LL_DataGetFirst(DataList);

					sData Data;

					for (ULONG i=0;i<nNumElements;i++)
					{
						if (DataList == NULL)
						{
							free(msg);
							return -1;
						}

						//Datenpakete auf den aktuellen Bereich berprfen

						Data = DataList->Data;

							#ifdef DebugMode
								sprintf(msg, "                   -  Paket %d; Start: %d; Length: %d; Text: %s\n",i,DataList->Data.nStart,
																		DataList->Data.nLength, DataList->Data.cStr);
								PrintDebug(msg);
							#endif

						if (t1 != t2)
						{
							if ((Data.nStart >= t1 && Data.nStart <= t2) ||
								((Data.nStart+Data.nLength) >= t1 && (Data.nStart+Data.nLength) <= t2) ||
								(Data.nStart <= t1) && (Data.nStart+Data.nLength) > t2)
								DataTempList = LL_DataAdd(DataTempList, Data);
						}
						else
							DataTempList = LL_DataAdd(DataTempList, Data);


						
					LL_DataNode *DListTmp = LL_DataGetNext(DataList);
						if (DListTmp == NULL)
							break;
						DataList = DListTmp;

					}


						#ifdef DebugMode
							sprintf(msg, "                   -  %d von %d Paketen extrahiert; Dauer: %dms\n",
											LL_DataGetNumElements(DataTempList), nNumElements, (GetTickCount()-dStart));
							PrintDebug(msg);
						#endif

				}
			}

			

/*
			
			//Berechnung des Multi-Channels
			//hat nichts mit den reinen Interpretern zu tun!
			//
			// es werden hier zustzliche Datenpakete zurck gegeben
			// (t2-t1)
			//

			//keinen Multi-Channel gewhlt
			if (nMultiChannel < 0)
			{
				#ifdef DebugMode
					sprintf(msg, "                   -  keinen Multi-Channel ausgewhlt\n");
					PrintDebug(msg);
				#endif

				free(msg);
				if (DataTempList == NULL)
					return 0;
				else
					return LL_DataGetNumElements(DataTempList);
			}

			int nNumMultiPakets = (t2 - t1);

			
			sData Data;
			char strValue[100];

			for (int i=0;i<nNumMultiPakets;i++)
			{
				Data.cChannel = nMultiChannel;
				Data.cColor	= 0;
				Data.cText = 0;
				Data.cType = 0;
				Data.nLength = 1;
				Data.nStart = t1+i;
				Data.nValue = 0;

				//durchlaufe alle Kanle und addiere 

				for (int k = nMulti1; k<nMulti2; k++)
				{
					if (IsSet(gl_HWInfo, gl_buffer, k, i) == 1)
					{
						Data.nValue += potentiate(2, k-nMulti1);
					}
				}

				itoa(Data.nValue,strValue,16);
				strncpy(Data.cStr,strValue,32);

				DataTempList = LL_DataAdd(DataTempList,Data);
			}
*/
			free(msg);
			return LL_DataGetNumElements(DataTempList);

		}


		// Temporre Datenliste zurck geben

		if (todo == 1)
		{
			unsigned int nNumElements;
			nNumElements = LL_DataGetNumElements(DataTempList);

			if (nNumData < nNumElements)
			{
				#ifdef DebugMode
					sprintf(msg, "                   - Nicht ausreichend Platz ([nNumData] ist: %d; soll: %d).\n",
										nNumData, nNumElements);
					PrintDebug(msg);
				#endif
				free(msg);
				return 0;
			}

			if (DataTempList == NULL)
			{
				#ifdef DebugMode
					sprintf(msg, "                   - DataTempList == NULL\n");
					PrintDebug(msg);
				#endif
				free(msg);
				return 0;
			}
	


			DataTempList = LL_DataGetFirst(DataTempList);
			
			int nBitPos = 0;
			int nPaketSize = 45;

			//Daten zurckgeben
			for (ULONG i=0;i<nNumElements;i++)
			{
				if (DataTempList == NULL)
				{
					free(msg);
					return -1;
				}

				nBitPos = 0;

				//Aufbau der Datenrckgabe:
				// 16 Btyes:
				//	0:		char cText
				//	1:		char cType
				//	2:		char cColor
				//	3:		char cChannel
				//	4-7:	ULONG nValue
				//	8-11:	ULONG nStart
				//	12-15:	ULONG nLength

				//ACHTUNG
				//neues Paket:

				//	0:		char cText
				//	1:		char cType
				//	2:		char cColor
				//	3:		char cChannel
				//	4-36:	char nValue
				//	37-40:	ULONG nStart
				//	41-44:	ULONG nLength

				cData[(i*nPaketSize)+nBitPos++] = DataTempList->Data.cText;
				cData[(i*nPaketSize)+nBitPos++] = DataTempList->Data.cType;
				cData[(i*nPaketSize)+nBitPos++] = DataTempList->Data.cColor;
				cData[(i*nPaketSize)+nBitPos++] = DataTempList->Data.cChannel;



				//nValue
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
/*
				cData[(i*16)+4] = CalcByte(DataTempList->Data.nValue,0);
				cData[(i*16)+5] = CalcByte(DataTempList->Data.nValue,1);
				cData[(i*16)+6] = CalcByte(DataTempList->Data.nValue,2);
				cData[(i*16)+7] = CalcByte(DataTempList->Data.nValue,3);
*/

				for (int j=0;j<33;j++)
					cData[(i*nPaketSize) + nBitPos++] = DataTempList->Data.cStr[j];

				//nStart
				cData[(i*nPaketSize)+nBitPos++] = CalcByte(DataTempList->Data.nStart,0);
				cData[(i*nPaketSize)+nBitPos++] = CalcByte(DataTempList->Data.nStart,1);
				cData[(i*nPaketSize)+nBitPos++] = CalcByte(DataTempList->Data.nStart,2);
				cData[(i*nPaketSize)+nBitPos++] = CalcByte(DataTempList->Data.nStart,3);


				//nLength
				cData[(i*nPaketSize)+nBitPos++] = CalcByte(DataTempList->Data.nLength,0);
				cData[(i*nPaketSize)+nBitPos++] = CalcByte(DataTempList->Data.nLength,1);
				cData[(i*nPaketSize)+nBitPos++] = CalcByte(DataTempList->Data.nLength,2);
				cData[(i*nPaketSize)+nBitPos++] = CalcByte(DataTempList->Data.nLength,3);

				#ifdef DebugMode
								sprintf(msg, "                   -  Paket %d; Start: %d; Length: %d; Value: %d\n",i,DataTempList->Data.nStart,
																		DataTempList->Data.nLength, DataTempList->Data.nValue);
					PrintDebug(msg);
				#endif



				//Nchstes Datenpaket (wenn dies nicht das letzte ist
				if (i != (nNumElements-1))
					DataTempList = LL_DataGetNext(DataTempList);

			}

				#ifdef DebugMode
					sprintf(msg, "                   -  %d aus %d Pakete kopiert; Dauer: %dms\n",
									nNumElements,LL_DataGetNumElements(DataList), (GetTickCount()-dStart));
					PrintDebug(msg);
				#endif


		}
		if (msg != NULL)
			free(msg);
		return 1;
	}


	/////////////////////////////////////////////////////////
	// alte konvertierungsfunktion
	// sollte nicht weiter benutzt und spter gelscht werden
	/////////////////////////////////////////////////////////
	dllExp ULONG la_exp_convert_data(ULONG todo, ULONG nNumData, unsigned char *cData, 
			LA_HWInfo HWInfo, LA_Configuration LAConf, unsigned char *la_buffer, unsigned long t1, unsigned long t2)
	{
		

		char *msg;
		msg = (char*)malloc(sizeof(char)*1000);
		

			#ifdef DebugMode

				sprintf(msg, " [DLL] convert_data(); (veraltete Funktion!) Begin;todo = %d,  cData %d; nNumData %d\n",todo, cData, nNumData);	
				PrintDebug(msg);

			
				sprintf(msg, " [DLL] convert_data(); HWInfo: AddressMask:%d BytesPerSample:%d ChanMax: %d SamplesMax:%d Version:%d\n",
											HWInfo.adress_mask, HWInfo.bytes_per_sample,
											HWInfo.channel_max, HWInfo.samples_max,
											HWInfo.version);	
				PrintDebug(msg);

				sprintf(msg, "                        sample_clock: %d\n", LAConf.sample_clock);	
				
				PrintDebug(msg);
				sprintf(msg, "   --VORSICHT: Funktion veraltet, sollte nicht mehr verwendet werden.");
				PrintDebug(msg);
			#endif

		DWORD dStart = GetTickCount();



		if (todo == 3)
		{
			int i;

			if (DataList != NULL)
			{
				DataList = LL_DataClearList(DataList);
			}

			DataList = NULL;


//			Testdaten
//			Auf Kanal 1,2
//			100 Datenpakete Pro Kanal
//			mit leerem Zwischenraum
//			Vorsicht: Auf Kanal 1,2 mssen Interpreter aktiviert werden!
			sData Data;

			t1 = t2;

			unsigned long nStep = (HWInfo.samples_max / 150);
			unsigned long nLength = nStep - (nStep/3);
			for (int j=1;j<3;j++)
				for (i=0;i<20;i++)
				{

					Data.cChannel	= j;
					if (j==1)
						Data.cColor		= i%3;
					else
						Data.cColor		= 0;

					if (j==2)
						Data.cText		= i%3;
					else
						Data.cText		= 0;
					Data.cType		= 0;
					Data.nValue		= ((i+5)%256);
					if (j==1)
						Data.nStart		= (i*nStep);
					else
						Data.nStart		= (i*nStep)+1;
					Data.nLength	= nLength;


					DataList = LL_DataAdd(DataList, Data);

				}


			#ifdef DebugMode
				sprintf(msg, " [DLL] convert_data(); TEST-Version; 1. Aufruf; Dauer: %dms; Rckgabewert: %d\n",
							GetTickCount()-dStart, LL_DataGetNumElements(DataList));	
	
				PrintDebug(msg);
				
			#endif

			free(msg);


			return LL_DataGetNumElements(DataList);
		}



		//Daten mssen interpretiert und gezhlt werden!
		if (todo == 0)
		{
			
			int i;

			if (DataList != NULL)
			{
				DataList = LL_DataClearList(DataList);
			}

			DataList = NULL;

			//interpretieren

			//alle Spezial-Kanle Durchlaufen
			
			int nNumChan =0;

			//Keine Daten zu interpretieren!
			if (ChanList == NULL)
			{
				#ifdef DebugMode
					sprintf(msg, " [DLL] convert_data(); Keine Spezialkanle gewhlt.\n");	
					PrintDebug(msg);
				#endif
				free(msg);
				return 0;
			}

			nNumChan = LL_ChanInfoGetNumElements(ChanList);

				#ifdef DebugMode
					sprintf(msg, " [DLL] convert_data(); Anzahl d. Spezialkanle: %d\n", nNumChan);	
					PrintDebug(msg);
				#endif

			ChanList = LL_ChanInfoGetFirst(ChanList);

	/*
			Neue Funktionalitt:
				Es sollen nur Datenpakete zwischen t1 und t2 zurck gegeben werden!
				Eine weitere verkettete Liste wird initialisiert und mit den richtigen Daten gefllt

				t1 = t2
					->  Es werden keine zeitlichen Unterteilungen
						beachtet.

	*/

	/*
				t1 = 0;
				t2 = 0;
	//*/


			for (i=0;i<nNumChan;i++)
			{

				if (ChanList != NULL)
				{
					
					if (ChanList->ChanInfo.bUseInterpreter == 1)
					{
						
						//welcher Interpreter?
						switch(ChanList->ChanInfo.nInterpreterNr)
						{
						case 1:		//SPI
							{
								int res;
								res = ConvertSpi(HWInfo, ChanList->ChanInfo.nChannel, ChanList->ChanInfo.SpiCfg, la_buffer, &DataList);
									#ifdef DebugMode
										sprintf(msg, "                            %d.Spezialkanal(%d): SPI\n", 
																					i+1,ChanList->ChanInfo.nChannel);
										PrintDebug(msg);
										sprintf(msg, "                               Ret.: %d\n", res);
										PrintDebug(msg);
									#endif

								break;
							}

						case 2:		//RS232
							{
								int res;
								res = ConvertRS232(HWInfo, LAConf, ChanList->ChanInfo.nChannel, 
												ChanList->ChanInfo.RsCfg, la_buffer, &DataList);
									#ifdef DebugMode
										sprintf(msg, "                            %d.Spezialkanal(Kanal: %d): RS232\n", 
																					i+1,ChanList->ChanInfo.nChannel);	
										PrintDebug(msg);
									#endif
								break;
							}
						}

					}

				//nchsten Spezialkanal abarbeiten
					if (i <nNumChan-1)
						ChanList = LL_ChanInfoGetNext(ChanList);
				}


				if (ChanList == NULL)
				{
					#ifdef DebugMode
						sprintf(msg, " [DLL] convert_data() ChanList == NULL; Abbruch!\n");	
						PrintDebug(msg);
					#endif
					break;
				}


			}


			#ifdef DebugMode
				sprintf(msg, " [DLL] convert_data(); Interpretierte-Version; 1. Aufruf; Dauer: %dms; Rckgabewert: %d\n",
					GetTickCount()-dStart,LL_DataGetNumElements(DataList));	
	
				PrintDebug(msg);
				
			#endif

			free(msg);

	//	LA_EXP_startNew();
			return LL_DataGetNumElements(DataList);
		}
		else
		{
			// 2. Aufruf!
			//Status:	Dieser Teilabschnitt wandelt die LList Data
			//			in das Array um und gibt es zurck

			ULONG nNumElements = 0;

			nNumElements = LL_DataGetNumElements(DataList);	
			//Fehlercodes:

			if (nNumElements > nNumData)
			{
				#ifdef DebugMode
					sprintf(msg, " [DLL] convert_data(); TEST-Version; 2. Aufruf; FEHLER: nNumData nicht richtig\n");	
					PrintDebug(msg);
				#endif

				free(msg);

				return 1;
			}

			if (nNumData == 0)
			{
				#ifdef DebugMode
					sprintf(msg, " [DLL] convert_data(); TEST-Version; 2. Aufruf; Keine Daten gefunden.\n");	
					PrintDebug(msg);
				#endif

				free(msg);

				return 0;
			}

			DataList = LL_DataGetFirst(DataList);

					#ifdef DebugMode
						sprintf(msg, "     [DLL] convert_data(); nNumElements.: %d\n", nNumElements);	
						PrintDebug(msg);
					#endif




			for (ULONG i=0;i<nNumElements;i++)
			{
				if (DataList == NULL)
				{
					free(msg);
					return -1;
				}
				//Aufbau der Datenrckgabe:
				// 16 Btyes:
				//	0:		char cText
				//	1:		char cType
				//	2:		char cColor
				//	3:		char cChannel
				//	4-7:	ULONG nValue
				//	8-11:	ULONG nStart
				//	12-15:	ULONG nLength

				DataList->Data.nValue *= 1;
				DataList->Data.nStart *= 1;

				cData[(i*16)+0] = DataList->Data.cText;
				cData[(i*16)+1] = DataList->Data.cType;
				cData[(i*16)+2] = DataList->Data.cColor;
				cData[(i*16)+3] = DataList->Data.cChannel;


				//nValue
				cData[(i*16)+4] = CalcByte(DataList->Data.nValue,0);
				cData[(i*16)+5] = CalcByte(DataList->Data.nValue,1);
				cData[(i*16)+6] = CalcByte(DataList->Data.nValue,2);
				cData[(i*16)+7] = CalcByte(DataList->Data.nValue,3);

				//nStart
				cData[(i*16)+8] = CalcByte(DataList->Data.nStart,0);
				cData[(i*16)+9] = CalcByte(DataList->Data.nStart,1);
				cData[(i*16)+10] = CalcByte(DataList->Data.nStart,2);
				cData[(i*16)+11] = CalcByte(DataList->Data.nStart,3);


				//nLength
				cData[(i*16)+12] = CalcByte(DataList->Data.nLength,0);
				cData[(i*16)+13] = CalcByte(DataList->Data.nLength,1);
				cData[(i*16)+14] = CalcByte(DataList->Data.nLength,2);
				cData[(i*16)+15] = CalcByte(DataList->Data.nLength,3);
	/*				
					#ifdef DebugMode
						sprintf(msg, "     [DLL] convert_data(); Data(%d) Text(%d) Typ(%d) Color(%d) Channel(%d) nValue(%d) nStart(%d) nLength(%d) \n",
														i,
														cData[(i*16)+0],
														cData[(i*16)+1],
														cData[(i*16)+2],
														cData[(i*16)+3],
														DataList->Data.nValue,
														DataList->Data.nStart,
														DataList->Data.nLength);
														
						PrintDebug(msg);
					#endif
	*/					
				DataList = LL_DataGetNext(DataList);

			}

			DataList = LL_DataClearList(DataList);

		}


		#ifdef DebugMode
			sprintf(msg, "     [DLL] convert_data(); Dauer: %dms; ENDE\n",GetTickCount()-dStart);						
			PrintDebug(msg);
		#endif

		free(msg);


		return 0;
	}




















